import * as monaco from "monaco-editor";

export const theme: monaco.editor.IStandaloneThemeData = {
	base: "vs-dark",
	inherit: true,
	rules: [
        { token: '', foreground: '#ffffff' },
        { token: 'variable.language.self', foreground: '#569CD6' },
        { token: 'variable.parameter.variadic', foreground: '#569CD6' },
        { token: 'variable.parameter.function', foreground: '#569CD6' },
        { token: 'variable.other.constant', foreground: '#569CD6' },
        { token: 'variable.property', foreground: '#569CD6' },
        { token: 'variable.object.property', foreground: '#569CD6' },

        { token: 'keyword', foreground: '#569CD6' },
        { token: 'keyword.local', foreground: '#569CD6', fontStyle: 'bold' },
        { token: 'keyword.operator', foreground: '#D4D4D4' },
        { token: 'keyword.operator.type.annotation', foreground: '#569CD6' },
        { token: 'keyword.operator.typedef.annotation', foreground: '#569CD6' },
        { token: 'keyword.control.export', foreground: '#569CD6', fontStyle: 'italic' },

        { token: 'operator', foreground: '#569cd6' },
        { token: 'operator.type', foreground: '#569cd6' },
        { token: 'operator.special', foreground: '#569cd6' },

        { token: 'entity.name.type.alias', foreground: '#4EC9B0' },
        { token: 'entity.name.function', foreground: '#DCDCAA', fontStyle: 'bold' },

        { token: 'global', foreground: '#569cd6' },

        { token: 'storage.type', foreground: '#569CD6' },

        { token: 'comment', foreground: '#6A9955' },
        { token: 'comment.highlight.title', foreground: '#6A9955', fontStyle: 'italic' },
        { token: 'comment.highlight.name', foreground: '#6A9955', fontStyle: 'italic' },
        { token: 'comment.delimiter.modifier', foreground: '#6A9955', fontStyle: 'italic' },
        { token: 'comment.highlight.modifier', foreground: '#6A9955', fontStyle: 'italic' },
        { token: 'comment.highlight.descriptor', foreground: '#6A9955', fontStyle: 'italic' },

        { token: 'delimiter.longstring', foreground: '#89DDFF' },
        { token: 'delimiter.bracket', foreground: '#ffc93d' },
        { token: 'delimiter.array', foreground: '#ffc93d' },
        { token: 'delimiter.parenthesis', foreground: '#ffc93d' },
        { token: 'delimiter', foreground: '#a6afbd' },

        { token: 'string', foreground: '#CE9178' },
        { token: 'longstring', foreground: '#CE9178' },
        { token: 'string.delimeter', foreground: '#CE9178' },
        { token: 'string.escape', foreground: '#CE9178' },

        { token: 'punctuation.separator.arguments', foreground: '#CE9178' },
        { token: 'punctuation.separator.parameter', foreground: '#CE9178' },
        { token: 'punctuation.separator.table', foreground: '#CE9178' },
        { token: 'punctuation.definition.block', foreground: '#CE9178' },
        { token: 'punctuation.definition.parameters', foreground: '#CE9178' },
        { token: 'punctuation.definition.typeparameters', foreground: '#CE9178' },

        { token: 'constant.language', foreground: '#569CD6' },
        { token: 'number', foreground: '#B5CEA8' },
        { token: 'constants', foreground: '#569CD6', fontStyle: 'bold' },

        { token: 'support.function', foreground: '#DCDCAA', fontStyle: 'bold' },
        { token: 'support.function.library', foreground: '#9CDCFE' },
        { token: 'support.type', foreground: '#4EC9B0' },
    ],
    colors: {
        'editor.background': '#0A0A0A',
        'editorLineNumber.foreground': '#7A7A7A',
        'editorLineNumber.activeForeground': '#BBBBBB',
        'editorIndentGuide.background': '#0f0f0f',
        'editorSuggestWidget.background': "#0f0f0f",
        'editorSuggestWidget.border': "#000000",
        'editorSuggestWidget.foreground': "#D5D5D5",
        'editorSuggestWidget.selectedBackground': "#2b2b2b",
        'editorSuggestWidget.highlightForeground': "#18A0FB",
        'textCodeBlock.background': '#0f0f0f',
    }
};
