# Roblox Luau Language Server

[Original Project](https://github.com/sumneko/lua-language-server) by [sumneko](https://github.com/sumneko)

Make sure you don't have both [Lua](https://marketplace.visualstudio.com/items?itemName=sumneko.lua) by sumneko and Roblox LSP enabled.

## Install In VSCode
https://marketplace.visualstudio.com/items?itemName=Nightrains.robloxlsp

## More Info 
https://devforum.roblox.com/t/roblox-lsp-full-intellisense-for-roblox-and-luau/717745

## Get Help

Roblox OS Community Discord Server: https://discord.gg/c4nPcZHwFU


## Features

- [x] Exact Luau Environment
- [x] Full Luau Typechecking and Intellisense
- [x] Support for [Rojo](https://github.com/Roblox/rojo)
- [x] Support for Third-Party libraries like Roact, Rodux, Promise, TestEz, etc.
- [x] Color3 Preview and Picker
- [x] Auto-completion of game descendants
- [x] Auto-updatable API
- [x] Inlay Hints
- [x] Goto Definition
- [x] Find All References
- [x] Hover
- [x] Diagnostics
- [x] Rename
- [x] Auto Completion
- [x] IntelliSense
- [x] Signature Help
- [x] Document Symbols
- [x] Workspace Symbols
- [x] Syntax Check
- [x] Highlight
- [x] Code Action
- [x] EmmyLua Annotation
- [x] Multi Workspace
- [x] Semantic Tokens

### Preview

![avatar](https://i.imgur.com/4sgYDii.gif)
![avatar](https://i.imgur.com/vHbKIJ0.gif)
![avatar](https://cdn.discordapp.com/attachments/434146484758249482/778145929345368064/test.gif)

## Credit

* [lua-language-server](https://github.com/sumneko/lua-language-server)
* [vscode-luau](https://github.com/Dekkonot/vscode-luau)
* [bee.lua](https://github.com/actboy168/bee.lua)
* [luamake](https://github.com/actboy168/luamake)
* [lni](https://github.com/actboy168/lni)
* [LPegLabel](https://github.com/sqmedeiros/lpeglabel)
* [LuaParser](https://github.com/sumneko/LuaParser)
* [rcedit](https://github.com/electron/rcedit)
* [ScreenToGif](https://github.com/NickeManarin/ScreenToGif)
* [vscode-languageclient](https://github.com/microsoft/vscode-languageserver-node)
* [lua.tmbundle](https://github.com/textmate/lua.tmbundle)
* [EmmyLua](https://emmylua.github.io)
* [lua-glob](https://github.com/sumneko/lua-glob)
* [utility](https://github.com/sumneko/utility)
* [json.lua](https://github.com/actboy168/json.lua)

## Acknowledgement

* [sumneko](https://github.com/sumneko)
* [actboy168](https://github.com/actboy168)
* [Dekkonot](https://github.com/Dekkonot)
* [Dmitry Sannikov](https://github.com/dasannikov)
* [Jayden Charbonneau](https://github.com/Reshiram110)
* [Stjepan Bakrac](https://github.com/z16)
* [Peter Young](https://github.com/young40)
* [Li Xiaobin](https://github.com/Xiaobin0860)
* [Fedora7](https://github.com/Fedora7)
* [Allen Shaw](https://github.com/shuxiao9058)
* [Bartel](https://github.com/Letrab)
* [Ruin0x11](https://github.com/Ruin0x11)
* [uhziel](https://github.com/uhziel)
* [火凌之](https://github.com/PhoenixZeng)
* [CppCXY](https://github.com/CppCXY)
* [Ketho](https://github.com/Ketho)
* [Folke Lemaitre](https://github.com/folke)