using System;
using System.Collections.Generic;
using Octokit;

class Program
{
    static async System.Threading.Tasks.Task Main(string[] args)
    {
        Console.Write("Enter your GitHub username: ");
        string username = Console.ReadLine();

        var client = new GitHubClient(new ProductHeaderValue("GistLister"));

        try
        {
            var gists = await client.Gist.GetAll(username);

            Console.WriteLine($"Gists for user '{username}':");
            Console.WriteLine();

            foreach (var gist in gists)
            {
                Console.WriteLine($"Gist ID: {gist.Id}");
                Console.WriteLine($"Description: {gist.Description}");
                Console.WriteLine($"Files:");

                foreach (var file in gist.Files)
                {
                    Console.WriteLine($"- {file.Key}");
                }

                Console.WriteLine();
            }
        }
        catch (NotFoundException)
        {
            Console.WriteLine($"User '{username}' not found.");
        }
        catch (Exception ex)
        {
            Console.WriteLine($"An error occurred: {ex.Message}");
        }

        Console.WriteLine("Press any key to exit.");
        Console.ReadKey();
    }
}